"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ControllerMeta = exports.controllersMeta = void 0;
const method_meta_1 = require("./method.meta");
exports.controllersMeta = new Map();
class ControllerMeta {
    name = '';
    path = '';
    ref = null;
    methods = new Map();
    constructor(proto, name, ref, path) {
        let instance = exports.controllersMeta.get(proto);
        if (!instance) {
            instance = this;
            exports.controllersMeta.set(proto, instance);
        }
        name && (instance.name = name);
        ref && (instance.ref = ref);
        path && (instance.path = path);
        return instance;
    }
    getMethod(name) {
        let method = this.methods.get(name);
        if (!method) {
            method = new method_meta_1.MethodMeta(name);
            this.methods.set(name, method);
        }
        return method;
    }
}
exports.ControllerMeta = ControllerMeta;
