import { Request as TReq, Response as TRes } from 'lambda-api';
import { ZodTypeAny } from 'zod';
export type TGetter = (data: any, req: TReq, res: TRes) => any;
export type TValidator = ZodTypeAny | undefined;
export type TGuard = (req: TReq) => Promise<Boolean>;
export interface TApiConfig {
    action: string;
    path: string;
    method: string;
    guards: TGuard[];
}
export interface TParam {
    getter: TGetter;
    validator: TValidator;
    data: string;
    type?: Function;
}
export declare class MethodMeta {
    name: string;
    path: string;
    action: string;
    ref: Function | null;
    guards: TGuard[];
    params: TParam[];
    constructor(name: string);
    bindToApi(api: any, basePath: string, actionClass: Function): TApiConfig;
    toRoutePath(basePath: string): string;
    toRouteAction(actionMethod: Function, actionClass: Function): (req: TReq, res: TRes) => Promise<any>;
    toRouteParams(actionClass: Function): TParam[];
    toRouteGuard(): (req: TReq) => Promise<void>;
}
