"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try {
            step(generator.next(value));
        }
        catch (e) {
            reject(e);
        } }
        function rejected(value) { try {
            step(generator["throw"](value));
        }
        catch (e) {
            reject(e);
        } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function () { if (t[0] & 1)
            throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f)
            throw new TypeError("Generator is already executing.");
        while (_)
            try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                    return t;
                if (y = 0, t)
                    op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0:
                    case 1:
                        t = op;
                        break;
                    case 4:
                        _.label++;
                        return { value: op[1], done: false };
                    case 5:
                        _.label++;
                        y = op[1];
                        op = [0];
                        continue;
                    case 7:
                        op = _.ops.pop();
                        _.trys.pop();
                        continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                            _ = 0;
                            continue;
                        }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                            _.label = op[1];
                            break;
                        }
                        if (op[0] === 6 && _.label < t[1]) {
                            _.label = t[1];
                            t = op;
                            break;
                        }
                        if (t && _.label < t[2]) {
                            _.label = t[2];
                            _.ops.push(op);
                            break;
                        }
                        if (t[2])
                            _.ops.pop();
                        _.trys.pop();
                        continue;
                }
                op = body.call(thisArg, _);
            }
            catch (e) {
                op = [6, e];
                y = 0;
            }
            finally {
                f = t = 0;
            }
        if (op[0] & 5)
            throw op[1];
        return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator)
        throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
};
exports.__esModule = true;
exports.setResponse = exports.getBody = exports.getHeader = exports.getHeaders = exports.getCookies = exports.getQuery = exports.getIp = void 0;
var querystring_1 = require("querystring");
var utils_1 = require("./utils");
function getIp(req) {
    return 'not-implemented';
}
exports.getIp = getIp;
function getQuery(req) {
    var _a = req.url.split('?'), rawPath = _a[0], rawQueryString = _a[1];
    var queryParams = Object.entries(querystring_1.parse(rawQueryString))
        .reduce(function (out, _a) {
        var key = _a[0], val = _a[1];
        out[key] = Array.isArray(val)
            ? val.join(',')
            : val;
        return out;
    }, {});
    return { rawPath: rawPath, rawQueryString: rawQueryString, queryParams: queryParams };
}
exports.getQuery = getQuery;
function getCookies(req) {
    var cookies = getHeader(req, 'Cookie');
    if (!cookies) {
        return [];
    }
    return Array.isArray(cookies)
        ? cookies
        : cookies.split(';').map(function (s) { return s.trim(); });
}
exports.getCookies = getCookies;
function getHeaders(req) {
    return Object.entries(req.headers).reduce(function (out, _a) {
        var key = _a[0], val = _a[1];
        out[key] = Array.isArray(val)
            ? val.join(',')
            : val;
        return out;
    }, {});
}
exports.getHeaders = getHeaders;
function getHeader(req, key) {
    var value = req.headers[key]
        || req.headers[key.toLowerCase()]
        || '';
    return Array.isArray(value)
        ? value.join(',')
        : value;
}
exports.getHeader = getHeader;
function getBody(req) {
    var req_1, req_1_1;
    var e_1, _a;
    return __awaiter(this, void 0, void 0, function () {
        var buffers, chunk, e_1_1, err_1;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    if (req.method === 'GET'
                        || req.method === 'HEAD') {
                        return [2, undefined];
                    }
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, 14, , 15]);
                    buffers = [];
                    _b.label = 2;
                case 2:
                    _b.trys.push([2, 7, 8, 13]);
                    req_1 = __asyncValues(req);
                    _b.label = 3;
                case 3: return [4, req_1.next()];
                case 4:
                    if (!(req_1_1 = _b.sent(), !req_1_1.done))
                        return [3, 6];
                    chunk = req_1_1.value;
                    buffers.push(chunk);
                    _b.label = 5;
                case 5: return [3, 3];
                case 6: return [3, 13];
                case 7:
                    e_1_1 = _b.sent();
                    e_1 = { error: e_1_1 };
                    return [3, 13];
                case 8:
                    _b.trys.push([8, , 11, 12]);
                    if (!(req_1_1 && !req_1_1.done && (_a = req_1["return"])))
                        return [3, 10];
                    return [4, _a.call(req_1)];
                case 9:
                    _b.sent();
                    _b.label = 10;
                case 10: return [3, 12];
                case 11:
                    if (e_1)
                        throw e_1.error;
                    return [7];
                case 12: return [7];
                case 13: return [2, Buffer
                        .concat(buffers)
                        .toString('utf8')];
                case 14:
                    err_1 = _b.sent();
                    return [2, undefined];
                case 15: return [2];
            }
        });
    });
}
exports.getBody = getBody;
function setResponse(res, result) {
    if (utils_1.isError(result)) {
        res.writeHead(result.statusCode || result.code || 500, { 'Content-Type': 'text/plain' });
        res.write(utils_1.toString(result));
    }
    else if (!utils_1.isEvent(result)) {
        res.writeHead(result.statusCode || result.code || 200, { 'Content-Type': 'application/json' });
        res.write(utils_1.toString(result));
    }
    else {
        res.statusCode = result.statusCode;
        res.writeHead(result.statusCode, utils_1.toObject(result.headers));
        if (utils_1.isPlainObject(result.multiValueHeaders)) {
            Object.entries(result.multiValueHeaders).forEach(function (_a) {
                var key = _a[0], values = _a[1];
                Array.isArray(values)
                    ? values.forEach(function (value) { return res.setHeader(key, value); })
                    : res.setHeader(key, values);
            });
        }
        res.write(utils_1.toString(result.body), result.isBase64Encoded
            ? 'base64'
            : 'utf8');
    }
}
exports.setResponse = setResponse;
