import { IncomingMessage } from 'http';
import { APIGatewayProxyEventV2 } from 'aws-lambda';
export interface TMockLambdaOpts {
    apiId?: string;
    accountId?: string;
    logStreamId?: string;
    region?: string;
    functionName?: string;
    functionVersion?: string;
    routeKey?: string;
    stageName?: string;
    domainName?: string;
    logGroupName?: string;
    memoryLimitInMB?: string;
    apiVersion?: number;
}
export declare function MockLambda(opts: TMockLambdaOpts): {
    getEvent: (req: IncomingMessage) => Promise<APIGatewayProxyEventV2>;
    getContext: () => {
        callbackWaitsForEmptyEventLoop: boolean;
        functionVersion: string;
        functionName: string;
        memoryLimitInMB: string;
        logGroupName: string;
        logStreamName: string;
        invokedFunctionArn: string;
        awsRequestId: `${string}-${string}-${string}-${string}-${string}`;
        startedAt: number;
        getRemainingTimeInMillis: () => number;
        done: () => any;
        fail: () => any;
        succeed: () => any;
    };
};
